From e786bc3a52717f84758c6067f54aa596afeb90ca Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 617/1001] Readability, README, and comment improvements


* Update README to clarify that stream needs the feed setup
* Move stream code to its own class
* Add in Dropdown.jsx
* Explain the save tagging loop
* Adjust to removal of feed.py code from #237.

---

diff --git a/hubs/app.py b/hubs/app.py
index 925f3a3..cc32021 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -4,20 +4,16 @@ import json
 import logging
 import os
 import urlparse
-import uuid
 
 import flask
 import flask.json
-import fmn.lib
 import munch
-import pygments.formatters
-import six
 
 from flask.ext.oidc import OpenIDConnect
 
-import fmn.lib
 import hubs.models
 import hubs.widgets
+import hubs.stream
 
 import datanommer.models
 
@@ -50,7 +46,6 @@ import fedmsg.meta
 
 fedmsg_config = fedmsg.config.load_config()
 fedmsg.meta.make_processors(**fedmsg_config)
-paths = fmn.lib.load_rules(root='fmn.rules')
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 datanommer.models.init(fedmsg_config['datanommer.sqlalchemy.uri'])
@@ -520,31 +515,6 @@ def login_required(function):
 
     return decorated_function
 
-def apply_html(actions):
-    # Smash multiple messages into single ones
-    actions = fedmsg.meta.conglomerate(actions, lexers=True, **fedmsg_config)
-
-    # Apply some html markup to the subtitles for extra fanciness.
-    for match in actions:
-        match['markup'] = hubs.widgets.feed.apply_markup(match)
-        for idx, constituent in match['msg_ids'].items():
-            constituent['markup'] = hubs.widgets.feed.apply_markup(constituent)
-            if constituent['long_form'] != constituent['subtitle']:
-                if constituent.get('lexer'):
-                    constituent['long_form'] = pygments.highlight(
-                        constituent['long_form'],
-                        constituent['lexer'],
-                        pygments.formatters.HtmlFormatter(style='monokai'),
-                    )
-                else:
-                    markup = u"<h5>{long_form}</h5>".format(**constituent)
-                    constituent['long_form'] = markup
-        # And tack on a unique identifier for each top level entry.
-        match['dom_id'] = six.text_type(uuid.uuid4())
-
-    return actions
-
-
 @app.route('/<name>/stream')
 @app.route('/<name>/stream/')
 @login_required
@@ -553,67 +523,17 @@ def stream(name):
     saved = hubs.models.SavedNotification.by_username(session, name)
     saved = [n.__json__() for n in saved]
 
-    preference = {
-        'filters': [{
-            'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
-            'id': 20506,
-            'name': 'Events referring to my username',
-            'oneshot': None,
-            'rules': [
-                {
-                    'arguments': {
-                        'fasnick': name
-                    },
-                    'cache_key': '2f59dcddf85cab5822af8d40d82c7390ce0f80b40119f2db67f3037a0594a2a1',
-                    'code_path': 'fmn.rules:user_filter',
-                    'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
-                    'info': {
-                        'args': [
-                            'config',
-                            'message',
-                            'fasnick'
-                        ],
-                        'datanommer-hints': {},
-                        'doc': "<p>Use this rule to include messages that are associated with a\nspecific user.</p>",
-                        'doc-no-links': '<html><head></head><body><p>Use this rule to include messages that are associated with a\nspecific user.</p>\n</body></html>',
-                        'hints-invertible': True,
-                        'submodule': 'generic',
-                        'title': 'A particular user'
-                    },
-                    'negated': False
-                }]
-        }]
-    }
-    preference = hubs.widgets.feed.rehydrate_preference(preference)
-    messages = []
-    actions = []
-
-    delta = datetime.timedelta(days=365)
-    end = datetime.datetime.utcnow()
-
-    for fmn_filter in preference['filters']:
-        fmn_hinting = fmn.lib.hinting.gather_hinting(fedmsg_config, fmn_filter['rules'], paths)
-        total, pages, rows = datanommer.models.Message.grep(
-            start=end - delta,
-            end=end,
-            rows_per_page=100,
-            page=1,
-            order='desc',
-            **fmn_hinting
-        )
-        messages.extend(rows)
-
-    for message in messages:
-        original = message.__json__()
-        if name in fedmsg.meta.msg2usernames(original, **fedmsg_config):
-            actions.append(original)
+    stream = hubs.stream.Stream(name)
+    actions = stream.get_actions()
 
-    actions = apply_html(actions)
+    # An action that has already been saved should not have a saved button
+    # this tags all the saved actions so the front end can decide to display or not.
+    # This will get slow pretty quickly so we should reevaluate after flock
     for action in actions:
         if any(s['markup'] == action['markup'] for s in saved):
             action['saved'] = True
 
-    actions = json.dumps(actions, cls=hubs.widgets.feed.PythonObjectEncoder)
+    actions = json.dumps(actions, cls=hubs.stream.PythonObjectEncoder)
     return flask.render_template(
         'stream.html',
         hub=hub,
diff --git a/hubs/static/client/app/components/Dropdown.jsx b/hubs/static/client/app/components/Dropdown.jsx
new file mode 100644
index 0000000..57de016
--- /dev/null
+++ b/hubs/static/client/app/components/Dropdown.jsx
@@ -0,0 +1,54 @@
+import React from 'react';
+
+export default class Dropdown extends React.Component {
+  onClick() {
+    const payload = {
+      link: this.props.match.link,
+      markup: this.props.match.markup,
+      secondary_icon: this.props.match.secondary_icon,
+      dom_id: this.props.match.dom_id,
+    };
+
+    $.ajax({
+      type: 'POST',
+      url: this.props.saveUrl,
+      data: JSON.stringify(payload),
+      contentType: 'application/json',
+    }).done(() => {
+      const id = '#save-' + this.props.match.dom_id;
+      const $saveBtn = $(id);
+      $saveBtn.text('Saved');
+    });
+  }
+
+  render() {
+    let saveBtn;
+    if (!this.props.match.saved && this.props.saveUrl) {
+      saveBtn = (
+        <a
+          className="dropdown-item"
+          onClick={this.onClick.bind(this)}
+          href="#"
+        >
+          Save
+        </a>
+      );
+    }
+
+    return (
+      <div className="dropdown pull-sm-right">
+        <span
+          className="dropdown-toggle" type="button"
+          id={'save-' + this.props.match.dom_id}
+          data-toggle="dropdown" aria-haspopup="true"
+          aria-expanded="true"
+        >
+          More
+        </span>
+        <div className="dropdown-menu" aria-labelledby="dropdownMenu2">
+          {saveBtn}
+        </div>
+      </div>
+    );
+  }
+}
diff --git a/hubs/stream.py b/hubs/stream.py
new file mode 100644
index 0000000..2cbcadf
--- /dev/null
+++ b/hubs/stream.py
@@ -0,0 +1,153 @@
+import datetime
+import json
+import uuid
+
+import datanommer.models
+import flask
+import fmn.lib
+import munch
+import pygments.formatters
+import six
+
+import fedmsg.config
+import fedmsg.meta
+
+
+# TODO Temporary: This is a proof of concept for Flock
+# This needs to be done in fnm.lib
+class Stream(object):
+    paths = fmn.lib.load_rules(root='fmn.rules')
+    fedmsg_config = fedmsg.config.load_config()
+    delta = datetime.timedelta(days=365)
+    end = datetime.datetime.utcnow()
+
+    def __init__(self, name):
+        self.name = name
+        self.preference = {
+            'filters': [{
+                'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
+                'id': 20506,
+                'name': 'Events referring to my username',
+                'oneshot': None,
+                'rules': [
+                    {
+                        'arguments': {
+                            'fasnick': name
+                        },
+                        'cache_key':
+                        '2f59dcddf85cab5822af8d40d82c7390ce0f80b40119f2db67f3037a0594a2a1',
+                        'code_path': 'fmn.rules:user_filter',
+                        'created_on': 'Thu, 15 Jan 2015 16:07:43 GMT',
+                        'info': {
+                            'args': [
+                                'config', 'message', 'fasnick'
+                            ],
+                            'datanommer-hints': {},
+                            'doc':
+                            "<p>Use this rule to include messages that are associated with a\nspecific user.</p>",
+                            'doc-no-links':
+                            '<html><head></head><body><p>Use this rule to include messages that are associated with a\nspecific user.</p>\n</body></html>',
+                            'hints-invertible': True,
+                            'submodule': 'generic',
+                            'title': 'A particular user'
+                        },
+                        'negated': False
+                    }
+                ]
+            }]
+        }
+
+    def apply_html(self, matches):
+        # Smash multiple messages into single ones
+        matches = fedmsg.meta.conglomerate(matches,
+                                           lexers=True,
+                                           **self.fedmsg_config)
+
+        # Apply some html markup to the subtitles for extra fanciness.
+        for match in matches:
+            match['markup'] = self.apply_markup(match)
+            for idx, constituent in match['msg_ids'].items():
+                constituent['markup'] = self.apply_markup(constituent)
+                if constituent['long_form'] != constituent['subtitle']:
+                    if constituent.get('lexer'):
+                        constituent['long_form'] = pygments.highlight(
+                            constituent['long_form'],
+                            constituent['lexer'],
+                            pygments.formatters.HtmlFormatter(
+                                style='monokai'), )
+                    else:
+                        markup = u"<h5>{long_form}</h5>".format(**constituent)
+                        constituent['long_form'] = markup
+            # And tack on a unique identifier for each top level entry.
+            match['dom_id'] = six.text_type(uuid.uuid4())
+
+        return matches
+
+    def get_actions(self):
+        preference = self.rehydrate_preference(self.preference)
+        messages = []
+        actions = []
+
+        for fmn_filter in preference['filters']:
+            fmn_hinting = fmn.lib.hinting.gather_hinting(
+                self.fedmsg_config, fmn_filter['rules'], self.paths)
+            total, pages, rows = datanommer.models.Message.grep(
+                start=self.end - self.delta,
+                end=self.end,
+                rows_per_page=100,
+                page=1,
+                order='desc',
+                **fmn_hinting)
+            messages.extend(rows)
+
+        for message in messages:
+            original = message.__json__()
+            if self.name in fedmsg.meta.msg2usernames(original, **
+                                                      self.fedmsg_config):
+                actions.append(original)
+
+        return self.apply_html(actions)
+
+    def rehydrate_preference(self, preference):
+        for fltr in preference['filters']:
+            fltr['rules'] = [munch.Munch(r) for r in fltr['rules']]
+            for rule in fltr['rules']:
+                code_path = str(rule.code_path)
+                rule.fn = fedmsg.utils.load_class(code_path)
+
+        return preference
+
+    def apply_markup(self, match):
+        markup = match['subtitle']
+        for username in match['usernames']:
+            args = (username, '<a href="{url}">@{username}</a>'.format(
+                url=flask.url_for('hub', name=username),
+                username=username, ))
+            markup = markup.replace(*args)
+            # TODO -- have to add these to conglomerate first
+            # match['long_form'] = match['long_form'].replace(*args)
+
+        for package in match['packages']:
+            args = (package, '<a href="{url}">{package}</a>'.format(
+                url='https://apps.fedoraproject.org/packages/' + package,
+                package=package, ))
+            markup = markup.replace(*args)
+            # TODO -- have to add these to conglomerate first
+            # match['long_form'] = match['long_form'].replace(*args)
+
+        return markup
+
+
+class PythonObjectEncoder(json.JSONEncoder):
+    ''' A JSON encoder that handles python data structures in encoding'''
+
+    def default(self, obj):
+        if isinstance(obj, (list, dict, str, unicode, int, float, bool,
+                            type(None))):
+            return json.JSONEncoder.default(self, obj)
+        if isinstance(obj, set) or isinstance(obj, tuple):
+            return list(obj)
+        if isinstance(obj, object):
+            return obj.__dict__
+        else:
+            raise TypeError
